function [ap testAUC tp fp rec prec EER] = evaluate(tssPos,tssNeg,mode)
% <mode> = 0 : the scores are individual feature scores
% <mode> = 1 : the scores are accumulated feature scores

if nargin < 3
    mode = 0;
end

M = size(tssPos,1);
N = size(tssNeg,1);
maxNF = size(tssPos,2);
ap = zeros(maxNF,1);
testAUC = zeros(maxNF,1);
tp = cell(maxNF,1); fp = cell(maxNF,1);
rec = cell(maxNF,1); prec = cell(maxNF,1);
EER = zeros(maxNF,1);
accumulatedPosScore = zeros(M,1);
accumulatedNegScore = zeros(N,1);
for nF = 1:maxNF
    % Draw ROC curve and calculate AUC
    if mode == 0
        accumulatedNegScore = tssNeg(:,nF) + accumulatedNegScore;
        accumulatedPosScore = tssPos(:,nF) + accumulatedPosScore;
        allScore = [accumulatedPosScore;accumulatedNegScore]; % scores of all test images
%         allScore = [sum(tssPos(:,1:nF),2);sum(tssNeg(:,1:nF),2)]; % scores of all test images
    else
        allScore = [sum(tssPos(:,nF),2);sum(tssNeg(:,nF),2)]; % scores of all test images
    end
    gt = [ones(M,1);-1*ones(N,1)]; % ground truth of all test images
%     gt = [ones(size(tssPos,1),1);-1*ones(size(tssNeg,1),1)]; % ground truth of all test images
    [testAUC(nF) tp{nF}, fp{nF}] = calc_auc(allScore,gt); % obtain ROC curve by comparing predicted scores and ground truth
     % and true positive and false postive rate
    [ap(nF) rec{nF} prec{nF} EER(nF)] = getAP(gt,allScore);
end

